<h1 class="page-header">Pagina de Registro</h1>

<!-- Custom Success/Error Message -->
<div class="row show-hide-message">
  <div [ngClass]="messageClass">
    {{ message }}
  </div>
</div>

<!-- Registration Form -->
<form [formGroup]="form" (submit)="onRegisterSubmit()">

  <!-- Username Input -->
  <div class="form-group">
    <label for="username">Username</label>
    <div [ngClass]="{'has-error': (form.controls.username.errors && form.controls.username.dirty) || (!usernameValid && form.controls.username.dirty), 'has-success': !form.controls.username.errors && usernameValid}">
      <input type="text" name="username" class="form-control" autocomplete="off" placeholder="*Username" formControlName="username" (blur)="checkUsername()"  />
      <!-- Validation -->
      <ul class="help-block">
        <li *ngIf="form.controls.username.errors?.required && form.controls.username.dirty">El campo es requerido.</li>
        <li *ngIf="form.controls.username.errors?.minlength && form.controls.username.dirty || form.controls.username.errors?.maxlength && form.controls.username.dirty ">Minimos caracteres: 3, Maximos caracteres: 15</li>
        <li *ngIf="form.controls.username.errors?.validateUsername && form.controls.username.dirty">Username no debe tener caracteres especiales</li>
        <li *ngIf="usernameMessage">{{ usernameMessage }}</li>
      </ul>
    </div>
  </div>

  <!-- Email Input -->
  <div class="form-group">
    <label for="email">Email</label>
    <div [ngClass]="{'has-error': (form.controls.email.errors && form.controls.email.dirty) || (!emailValid && form.controls.email.dirty), 'has-success': !form.controls.email.errors && emailValid}">
      <input type="text" name="email" class="form-control" autocomplete="off" placeholder="*Email" formControlName="email" (blur)="checkEmail()" />
      <!-- Validation -->
      <ul class="help-block">
        <li *ngIf="form.controls.email.errors?.required && form.controls.email.dirty">This field is required</li>
        <li *ngIf="(form.controls.email.errors?.minlength && form.controls.email.dirty || form.controls.email.errors?.maxlength && form.controls.email.dirty ) && form.controls.email.dirty">Minimos caracteres: 5, Maximos caracteres: 30</li>
        <li *ngIf="form.controls.email.errors?.validateEmail && form.controls.email.dirty">Este debe ser un email válido.</li>
        <li *ngIf="emailMessage">{{ emailMessage}}</li>
      </ul>
    </div>
  </div>

  <!-- Password Input -->
  <div class="form-group">
    <label for="password">Password</label>
    <div [ngClass]="{'has-error': (form.controls.password.errors && form.controls.password.dirty), 'has-success': !form.controls.password.errors}">
      <input type="password" name="password" class="form-control" autocomplete="off" placeholder="*Password" formControlName="password" />
      <!-- Validation -->
      <ul class="help-block">
        <li *ngIf="form.controls.password.errors?.required && form.controls.password.dirty">El Campo es requerido</li>
        <li *ngIf="form.controls.password.errors?.minlength && form.controls.password.dirty || form.controls.password.errors?.maxlength && form.controls.password.dirty ">Minimos caracteres: 8, Maximos caracteres: 35</li>
        <li *ngIf="form.controls.password.errors?.validatePassword && form.controls.password.dirty">Password debe tener al menos 8 caracteres pero no más de 35</li>
      </ul>
    </div>
  </div>

  <!-- Confirm Password Input -->
  <div class="form-group">
    <label for="confirm">Confirmar Password</label>
    <div [ngClass]="{'has-error': (form.controls.confirm.errors && form.controls.confirm.dirty) || (form.errors?.matchingPasswords && form.controls.confirm.dirty), 'has-success': !form.controls.confirm.errors && !form.errors?.matchingPasswords}">
      <input type="password" name="confirm" class="form-control" autocomplete="off" placeholder="*Confirmar Password" formControlName="confirm" />
      <!-- Validation -->
      <ul class="help-block">
        <li *ngIf="form.controls.confirm.errors?.required && form.controls.confirm.dirty">El Password es requerido</li>
        <li *ngIf="form.errors?.matchingPasswords && form.controls.confirm.dirty">Password  no matcheado</li>
      </ul>
    </div>
  </div>

  <!-- Submit Input -->
  <input [disabled]="!form.valid || processing || !emailValid || !usernameValid" type="submit" class="btn btn-primary" value="Registrar" />

</form>
<!-- Registration Form /-->
